#include <htc.h>

#include "7seg.h"

#define R_LIMIT 1861    // resistor upper limit = 9900 ohm

void start7seg(void){
    TMR4IF = 0;
    TMR4IE = 1;
    TMR4 = 0;

    //TMR0IF = 1;
    //TMR0IE = 1;

    flg_dig = 0;
    TMR4ON = 1;
    //TMR0CS = 0; // TMR0 ON

    INTCON |= 0b11000000;
}

void set7seg_off(void){
    dig_num[0] = dig_num[1] = dig_num[2] = S_off;
}

void stop7seg(void){
    TMR4ON = 0;
    TMR4IE = 0;
    ///TMR0CS = 1; // TMR0 OFF
    //TMR0IE = 0;

    set7seg_off();
    LAT_SEG7_DIG |= MASK_SEG7_DIG;
    //LAT_SEG7_SEG &= MASK_SEG7_SEG;
    //LAT_SEG7_DP = 0;
}

void set7seg_int(unsigned int v){
    unsigned char n;
    if(v>999){
        v %= 1000;
    }

    //dig 0 = 100
    if(v < 100)
        dig_num[0] =  S_off;
    else{
        n = v / 100;
        dig_num[0] =  seg7[n];
        v -= n * 100;
    }

    //dig1 = 10
    if(v < 10 && dig_num[0] ==  S_off){
        dig_num[1] =  S_off;
    }else{
        n = v / 10;
        dig_num[1] =  seg7[n];
        v -= n * 10;
    }
    //dig2 = 10
    n = v;
    dig_num[2] =  seg7[n];
}

void set7seg_char(unsigned char c1, unsigned char c2, unsigned char c3){
    dig_num[0] = c1;
    dig_num[1] = c2;
    dig_num[2] = c3;
}
