

#ifndef SEG7_H
#define SEG7_H

#define MASK_SEG7_DIG 0b00000111
#define LAT_SEG7_DIG LATB
#define TRIS_SEG7_DIG 0b11111000
#define LAT_DIG1 LATB2  // top digit
#define LAT_DIG2 LATB1
#define LAT_DIG3 LATB0  // bottom digit
//#define MASK_SEG7_SEG 0b10000000
#define LAT_SEG7_SEG LATA
//#define LAT_SEG7_DP LATC7

unsigned char flg_dig;
unsigned char dig_num[3];
unsigned char dig_lat_bit[3] = {0b11111011, 0b11111101, 0b11111110};

#define sA 0b00010000
#define sB 0b00000100
#define sC 0b00000001
#define sD 0b10000000
#define sE 0b01000000
#define sF 0b00001000
#define sG 0b00000010
#define sDP 0b00000000

//  |  -a-  |
//  f       b
//  |  -g-  |
//  e       c
//  |  -d-  |

//            
#define S_0 sA | sB | sC | sD | sE | sF
#define S_1 sB | sC
#define S_2 sA | sB | sD | sE | sG
#define S_3 sA | sB | sC | sD | sG
#define S_4 sB | sC | sF | sG
#define S_5 sA | sC | sD | sF | sG
#define S_6 sA | sC | sD | sE | sF | sG
#define S_7 sA | sB | sC
#define S_8 sA | sB | sC | sD | sE | sF | sG
#define S_9 sA | sB | sC | sD | sF| sG

#define S_A sA | sB | sC | sE | sF | sG
#define S_B sC | sD | sE | sF | sG
#define S_C sA | sD | sE | sF
#define S_d sB | sC | sD | sE | sG
#define S_E sA | sD | sE | sF | sG
#define S_F sA | sE | sF | sG
#define S_G sA | sC | sD | sE | sF
#define S_H sB | sC | sE | sF | sG
#define S_L sD | sE | sF
#define S_M sA | sB | sC | sE | sF
#define S_n sC | sE | sG
#define S_o sC | sD | sE | sG
#define S_P sA | sB | sE | sF | sG
#define S_r sE | sG
#define S_t sD | sE | sF | sG
#define S_v sC | sD | sE


#define S_off 0x00
#define S__ sG //'-'
#define S_DP sDP // DP
#define S_o_up sA | sB | sG | sF    // upper o

const unsigned char seg7[] = {
        S_0, S_1, S_2, S_3, S_4, S_5, S_6, S_7, S_8, S_9,
    };

void start7seg(void);
void stop7seg(void);
void set7seg_off(void);
void set7seg_int(unsigned int v);
void set7seg_char(unsigned char c1, unsigned char c2, unsigned char c3);


#endif
